-- thanks goes to creators of BigWigs_Plugins/bars.lua and Chronometer
-- keep wowace alive, donate!

--[[ changes to make
	need to make some manual checks for "multi duration" spells... EG:  frost armor (mage), PW:shield (priest)
	need to add Forced Non-watch... things like Aspects?
]]

SpellReminder = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceHook-2.1", "AceConsole-2.0", "AceEvent-2.0", "FuBarPlugin-2.0", "Parser-3.0", "Sink-1.0")
local BS = AceLibrary("Babble-Spell-2.2")
local candybar = AceLibrary("CandyBar-2.0")

SpellReminder.hasIcon = "Interface\\Icons\\Ability_Warrior_BattleShout"
local defaultBarColor = {["r"] = 1, ["g"] = 0, ["b"] = 0, ["a"] = 1}

-- list of aura names for the spells, EG: Feed Pet = Feed Pet Effect
--[[
local effectNames = {
	[BS["Feed Pet"] ] = BS["Feed Pet Effect"]
}]]
--[[
local onSpellHit = {
	BS["Immolation Trap"],
	BS["Freezing Trap"],
	BS["Frostbolt"],
	BS["Firebolt"],
}
]]
--[[  -- try to detect when the effect FADES from an enemy
local singleTarget = { -- spells which can only be used one target at once
	BS["Polymorph"],
}
]]
-- stores information PER SPELL[Target]
local spellInfo = {
	casting = nil,
	current = {},
}

local function getOption(key)
	return SpellReminder.db.profile[key]
end
local function setOption(key, value)
	SpellReminder.db.profile[key] = value
end
SpellReminder.options = {
	type = "group",
	name = "SpellReminder",
	desc = "Options for SpellReminder.",
	handler = SpellReminder,
	args = {
		animGroup = {
			type = "group",
			order = 1,
			name = "Timer Bars",
			desc = "Setup bar animation options and scaling.",
			args = {
				startScale = {				
					type = "range",
					order = 1,
					name = "Start Scale",
					desc = "Default Bar Scale.",
					min = 0.2,
					max = 2.0,
					step = 0.1,
					get = getOption,
					set = setOption,
					passValue = "startScale",
				},
				stopScale = {
					type = "range",
					order = 2,
					name = "Emphasize Scale",
					desc = "Emphasized Bar Scale.",
					min = 0.2,
					max = 3.0,
					step = 0.1,
					get = getOption,
					set = setOption,
					passValue = "stopScale",
				},
				ttg = {
					type = "range",
					order = 3,
					name = "Tween Time",
					desc = "Total time of tween animation.",
					min = 0.1,
					max = 3.0,
					step = 0.1,
					get = getOption,
					set = setOption,
					passValue = "ttg",
				},
				growUp = {
					type = "toggle",
					order = 4,
					name = "Grow Up",
					desc = "Instructs the timer bars to grow upward instead of downward",
					get = function ()  return getOption("growup") end,
					set = function (v)
						setOption("growup",v)
						candybar:SetCandyBarGroupGrowth("SpellReminder", getOption("growup"))
					end,
				},
				spacer1 = { type = "header", order = 5 },
				lockBars = {
					type = "toggle",
					order = 6,
					name = "Lock timer bars",
					desc = "Lock the position of the timer bars.",
					get = function () return getOption("lockbars") end,
					set = function (v)
						setOption("lockbars",v)
						-- show/hide the anchors
						SpellReminder:ToggleAnchors()
					end
				},
				testBars = {
					type = "execute",
					order = 7,
					name = "Test Bars",
					desc = "Create sample reminder bars to test your layout.",
					func = "CreateTestBars",
				},
			},
		},
		spacer2 = { type = "header", order = 2 },
		spells = {
			type = "group",
			order = 3,
			name = "Spell Setup",
			desc = "Setup spell reminders.",
			args = {
				spacer = { type = "header", order = 100 },
				addNew = {
					type = "text",
					order = 101,
					name = "Add New Spell",
					desc = "Add a new spell to the watch list.",
					usage = "<name>",
					get = function () return "" end,
					set = function (v) SpellReminder:InstallWatch(v) SpellReminder:BuildSpellOptions() end,
				},
				addAll = {
					type = "execute",
					order = 102,
					name = "Add all spells",
					desc = "Attempts to scan your spellbook and watch all spells.",
					func = "InstallAllSpells",
				}
			}
		},
		spacer3 = { type = "header", order = 4 }
	},
}

function SpellReminder:OnInitialize()
    -- Called when the addon is loaded
	self:RegisterDB("SpellReminderDB","SpellReminderDBPerChar")
	self:RegisterDefaults('profile', {
		startScale	= 1,
		stopScale	= 1.5,
		ttg			= 0.3,
		growup		= false,
		lockbars	= false,
		barposition	= { normal = {} , emphasis = {} }
	})
	self:RegisterDefaults('char', {
		spellSetup	= {},
	})
end

function SpellReminder:watch(t)
--	self:Print(t.recipientName.." affected by "..t.abilityName)
--	self:UNIT_SPELLCAST_SUCCEEDED("player",t.abilityName)
end

function SpellReminder:OnEnable()
	
    -- Called when the addon is enabled
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	self:RegisterEvent("UNIT_SPELLMISS")
	self:RegisterEvent("PLAYER_DEAD")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterParserEvent({eventType = "Death"},"COMBAT_DEATH")

--	self:RegisterParserEvent({eventType = "Aura"},"watch")
--	self:RegisterParserEvent({eventType = "Aura"},function (t) self:UNIT_SPELLCAST_SUCCEEDED("player",t.abilityName) end)
	
	self:RegisterEvent("SpecialEvents_UnitBuffLost","SE_AURA_LOST")
	self:RegisterEvent("SpecialEvents_PlayerItemBuffLost","SE_ITEM_AURA_LOST")
--	self:RegisterParserEvent({eventType = "Fade",recipientID = "player"},"AURA_LOST")
--	self:RegisterParserEvent({eventType = "Fade",recipientID = "pet"},"AURA_LOST")
--	self:RegisterParserEvent({eventType = "Aura",recipientID = "pet"},"AURA_GAIN")
--	self:RegisterParserEvent({eventType = "Aura",recipientID = "player",recipientID = "pet"},"AURA_GAIN")
	--self:RegisterParserEvent({eventType = "Damage",sourceID = "player",isDoT = false},"watch")

--CHAT_MSG_SPELL_SELF_DAMAGE

	self.OnMenuRequest = self.options
	self:RegisterChatCommand('/SpellReminder', {
		type = 'execute',
		func = function()
			self:OpenMenu()
		end
	})

	-- create anchors
	self:CreateAnchors()
	
	-- setup candybar
	candybar:RegisterCandyBarGroup("SpellReminderNormal")
	candybar:SetCandyBarGroupPoint("SpellReminderNormal", "TOP", self.normalAnchor, "BOTTOM", 0, 0)	
	candybar:SetCandyBarGroupGrowth("SpellReminderNormal", getOption("growup"))	

	candybar:RegisterCandyBarGroup("SpellReminderEmphasis")
	candybar:SetCandyBarGroupPoint("SpellReminderEmphasis", "TOP", self.emphasisAnchor, "BOTTOM", 0, 0)	
	candybar:SetCandyBarGroupGrowth("SpellReminderEmphasis", getOption("growup"))	
	
	-- SETUP SPELLS - check for talents which extend, like booming voice
--	self:InstallWatch(BS["Battle Shout"],"Warrior Buff",20)
--	self:InstallWatch(BS["Commanding Shout"],"Warrior Buff",20)
--	self:InstallWatch(BS["Demoralizing Shout"],"Warrior Debuff",10)
	
	--deserialise spellsetup
	table.foreach(self.db.char.spellSetup, function(k,v) self:WatchSpell(k,v.s,v.r)  end)
	
	self:BuildSpellOptions()
end

function SpellReminder:OnDisable()
    -- Called when the addon is disabled
	self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:UnregisterEvent("UNIT_SPELLCAST_SENT")
	self:UnregisterEvent("UNIT_SPELLCAST_STOP")
	self:UnregisterEvent("UNIT_SPELLMISS")
	self:UnregisterEvent("PLAYER_DEAD")
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterParserEvent({eventType = "Death"},"COMBAT_DEATH")
	self:UnregisterParserEvent({eventType = "Fade",recipientID = "player"},"AURA_LOST")
	self:UnregisterParserEvent({eventType = "Aura",recipientID = "player"},"AURA_GAIN")

	-- stop all spell watch events
	table.foreach(self.db.char.spellSetup, function(k,v) self:CancelWatchSpell(k) end)
	candybar:UnregisterCandyBarGroup("SpellReminderNormal")
	candybar:UnregisterCandyBarGroup("SpellReminderEmphasis")
end

function SpellReminder:CreateAnchors()
	self.normalAnchor = self:CreateAnchor("normal","Normal Bars",0.3,1,0.3)
	self.emphasisAnchor = self:CreateAnchor("emphasis","Emphasised Bars",0.3,1,0.3)
	self:ToggleAnchors()
end

function SpellReminder:ToggleAnchors()
	if getOption("lockbars") then
		self.normalAnchor:Hide()
		self.emphasisAnchor:Hide()
	else
		self.normalAnchor:Show()
		self.emphasisAnchor:Show()
	end
end

function SpellReminder:CreateAnchor(name, text, cRed, cGreen, cBlue)
	local f = CreateFrame("Button", nil, UIParent)
	f:SetWidth(200)
	f:SetHeight(25)

	f.owner = self

	if self.db.profile.barposition[name].x and self.db.profile.barposition[name].y then
		f:ClearAllPoints()
		f:SetPoint("TOPLEFT", UIParent, "TOPLEFT", self.db.profile.barposition[name].x, self.db.profile.barposition[name].y)
	else
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 50)
	end

	f:SetScript("OnDragStart", function() this:StartMoving() end )
	f:SetScript("OnDragStop",
		function()
			this:StopMovingOrSizing()
			local _, _, _, x, y = this:GetPoint()
			this.owner.db.profile.barposition[name].x = math.floor(x)
			this.owner.db.profile.barposition[name].y = math.floor(y)
        end)

	f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                                            tile = false, tileSize = 16, edgeSize = 16,
                                            insets = { left = 5, right =5, top = 5, bottom = 5 }})
	f:SetBackdropColor(cRed,cGreen,cBlue,.6)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")

	f.Text = f:CreateFontString(nil, "OVERLAY")
	f.Text:SetFontObject(GameFontNormalSmall)
	f.Text:ClearAllPoints()
	f.Text:SetTextColor(1, 1, 1, 1)
	f.Text:SetWidth(200)
	f.Text:SetHeight(25)
	f.Text:SetPoint("TOPLEFT", f, "TOPLEFT")
	f.Text:SetJustifyH("CENTER")
	f.Text:SetJustifyV("MIDDLE")
	f.Text:SetText(text)

	f:Hide()

	return f
end

function SpellReminder:CreateTestBars()
	self:CreateReminderBar("TEST_MANUAL","Test",30, 10)
	local i,added = 1,0
	while true do
		if added == 3 then break end
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spell) then	break end
		local durationBuff, durationDebuff = self:GetDuration(spell)
		if durationBuff ~= nil and durationBuff <= 30 then
			self:CreateReminderBar("TEST"..added,spell,durationBuff,math.ceil(durationBuff*.125))
			added = added + 1
		end
		i = i + 1
	end
end

function SpellReminder:BuildSpellOptions()
	local i = 0
	table.foreach(self.db.char.spellSetup, function(spellName,info)
		local durationBuff, durationDebuff = self:GetDuration(spellName)
		if durationBuff == nil then return end -- this can happen if the spell isnt available on this character, ie, it has been untrained
		i = i + 1
		self.options.args.spells.args["spell_"..string.gsub(spellName," ","_")] = {
			type = "group",
			order = i,
			name = spellName,
			desc = "Setup reminder for "..spellName,
			args = {
				active = {
					type = "toggle",
					order = 1,
					name = "Active",
					desc = "Track this spell?",
					get = function () return self.db.char.spellSetup[spellName].active end,
					set = function (v) self.db.char.spellSetup[spellName].active = v end,
				},
				sharedName = {
					type = "text",
					order = 2,
					name = "Shared Name",
					desc = "A common name across unique spells, EG: only one warrior shout can be active at once.",
					get = function () return self.db.char.spellSetup[spellName].s end,
					set = function (v) self.db.char.spellSetup[spellName].s = v end,
					usage = "<name>",
				},
				reminder = {
					type = "range",
					order = 3,
					name = "Reminder",
					desc = "Reminder occurs when the spell duration remaining reaches this value.",
					min = 0,
					max = durationBuff,
					step = 1,
					get = function () return self.db.char.spellSetup[spellName].r end,
					set = function (v) self.db.char.spellSetup[spellName].r = v end,
				},
				color = {
					type = "color",
					order = 5,
					name = "Bar Color",
					desc = "Set the color of the reminder bar.",
					get = function () local c = self.db.char.spellSetup[spellName].c or defaultBarColor return c.r,c.g,c.b,c.a end,
					set = function (r, g, b, a) self.db.char.spellSetup[spellName].c = {["r"]=r, ["g"]=g, ["b"]=b, ["a"]=1} end,					
				}
			}
		}
		
		if durationDebuff == nil then return end
		self.options.args.spells.args["spell_"..string.gsub(spellName," ","_")].args.reminderDebuff = {
			type = "range",
			order = 4,
			name = "Debuff Reminder",
			desc = "Reminder occurs when the spells debuff duration remaining reaches this value.",
			min = 0,
			max = durationDebuff,
			step = 1,
			get = function () return self.db.char.spellSetup[spellName].rd end,
			set = function (v) self.db.char.spellSetup[spellName].rd = v end,
		}
	end)
end

function SpellReminder:InstallWatch(spellName,sharedName,reminder)
	local durationBuff, durationDebuff = self:GetDuration(spellName)
	if durationBuff == nil then --[[self:Print("Cannot find spell/duration for "..spellName)]] return end -- this can happen if the spell isnt available on this character
	local _active,_reminder,_reminderD,_sharedName = true,nil,nil
	if self.db.char.spellSetup[spellName] ~= nil then
		_active		= self.db.char.spellSetup[spellName].active
		_reminder	= self.db.char.spellSetup[spellName].r
		_reminderD	= self.db.char.spellSetup[spellName].rd
		_sharedName	= self.db.char.spellSetup[spellName].s
	end
	self.db.char.spellSetup[spellName] = {active=_active, r=_reminder or reminder or math.ceil(durationBuff*0.125), s=_sharedName or sharedName or spellName, d=durationBuff }
	if durationDebuff ~= nil then
		self.db.char.spellSetup[spellName].rd = _reminderD or math.ceil(durationDebuff*0.125)
		self.db.char.spellSetup[spellName].dd = durationDebuff
	end
	
	self:WatchSpell(spellName)
end

function SpellReminder:InstallAllSpells()
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spell) then	break end
		self:InstallWatch(spell)
		i = i + 1
	end
	-- still not found? try pets spellbook
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_PET)
		if (not spell) then	break end
		self:InstallWatch(spell)
		i = i + 1
	end
	self:BuildSpellOptions()
end

function SpellReminder:WatchSpell(spellName)
	local durationBuff, durationDebuff = self:GetDuration(spellName)
	if durationBuff == nil then -- this can happen if the spell isnt available on this character, ie, it has been untrained
		self.db.char.spellSetup[spellName] = nil -- uninstall the watch
		return
	end
	
	self.db.char.spellSetup[spellName].d = durationBuff

	local info = self.db.char.spellSetup[spellName]
	if info == nil then return end
	if info["active"] ~= true then return end
	
--	self:RegisterEvent(info.eventName,"OnDurationEnding")
end

function SpellReminder:CancelWatchSpell(spellName)
--	self:UnregisterEvent(self.db.char.spellSetup[spellName].eventName)
	self.db.char.spellSetup[spellName].active = false
end

function SpellReminder:UNIT_SPELLCAST_SENT(caster,name,rank,target)
	if caster ~= "player" then return end
	local info = self.db.char.spellSetup[name]
	if info == nil then return end
	if info.active ~= true then return end
	
--	self:Print("spellcast sent: "..name)
	spellInfo.casting = {n=name, r=rank,t=target, eventName="DURATION_ENDING_"..(info.s or name)..";"}
end

function SpellReminder:UNIT_SPELLCAST_STOP(caster)
	if caster ~= "player" then return end
	spellInfo.casting = nil
end

function SpellReminder:UNIT_SPELLMISS(caster,action)
	--self:Print("spellmiss")
	
	-- at a guess, spellmiss comes before spellsucceeded
	-- cancel the event
	spellInfo.casting = nil
end

function SpellReminder:UNIT_SPELLCAST_SUCCEEDED(caster,name,rank)
	if caster ~= "player" then return end
	--self:Print(spellInfo.casting)
	if spellInfo.casting == nil then return end
	
	local info = self.db.char.spellSetup[name]
	if info == nil then return end
	if info.active ~= true then return end
	
--	self:Print("spellsuccess: "..name)
	
	self:CreateReminderBar(spellInfo.casting.eventName,name,info.d,info.r,spellInfo.casting.t,info.c)
end

function SpellReminder:CreateReminderBar(e, spellname, duration, reminder, target, color)
	if target == UnitName("player") then target = "" end
	color = color or defaultBarColor

	-- build name
	local text = spellname
	if target and target ~= "" then
		text = text.." ("..target..")"
		e = e..(target or "")
	end
	
	self:CancelScheduledEvent("GrowBar_"..e)
	self:ScheduleEvent(e, self.OnDurationEnding, duration-(reminder+1), self, e)
	
	candybar:RegisterCandyBar(e, duration, text, nil, color.r,color.g,color.b)
	candybar:RegisterCandyBarWithGroup(e,"SpellReminderNormal")
	candybar:SetCandyBarText(e,text)
	candybar:SetCandyBarIcon(e,self:GetTexture(spellname))
	candybar:SetCandyBarCompletion(e,self.OnDurationEnded,self,e)
	candybar:SetCandyBarScale(e,getOption("startScale"))
	candybar:StartCandyBar(e,false)
	
	spellInfo.current[e] = {n=spellname, r=reminder, t=target, eventName=e}
	spellInfo.casting = nil
end

function SpellReminder:PLAYER_DEAD()
	table.foreach(spellInfo.current, function(e,info)
		if info ~= nil then
			self:CancelScheduledEvent(e)
			candybar:StopCandyBar(e,false)
		end
	end)
end

--  we must assume that on the death of this target, that all watched spells with this targets name apply to this death... 
function SpellReminder:COMBAT_DEATH(t)
	table.foreach(spellInfo.current, function (eventName,info)
		if info.t == t.recipientName then -- call OnDurationEnded
			self:OnDurationEnded(eventName,true)
		end
	end)
end

function SpellReminder:SE_ITEM_AURA_LOST(name, rank, unknown)
--self:Print("SE_ITEM_AURA_LOST "..name)
	suffixes = {""," Weapon"}
	table.foreach(suffixes, function(_,suffix)
		local checkName = name..suffix
		table.foreach(spellInfo.current, function (eventName,info)
			if info.n == checkName and (info.t == nil or info.t == "") then -- call OnDurationEnded
				self:OnDurationEnded(eventName)
				return
			end
		end)
	end)
end
function SpellReminder:SE_AURA_LOST(unit, name, count, icon, rank, duration)
--self:Print("SE_AURA_LOST "..name)
	suffixes = {""," Totem"}
	table.foreach(suffixes, function(_,suffix)
		local checkName = name..suffix
		table.foreach(spellInfo.current, function (eventName,info)
			if info.n == checkName and ((info.t == nil or info.t == "") or (info.t == unit or info.t == UnitName(unit))) then -- call OnDurationEnded
				self:OnDurationEnded(eventName)
				return
			end
		end)
	end)
end

function SpellReminder:AURA_LOST(t)
--self:Print("AURA_LOST "..t.abilityName)
	table.foreach(spellInfo.current, function (eventName,info)
		if info.n == t.abilityName and (info.t == nil or t.recipientName == info.t or info.t == "") then -- call OnDurationEnded
			self:OnDurationEnded(eventName)
		end
	end)
end

function SpellReminder:AURA_GAIN(t)
	self:UNIT_SPELLCAST_SENT("player",t.abilityName)
	self:UNIT_SPELLCAST_SUCCEEDED("player",t.abilityName)
end

function SpellReminder:PLAYER_REGEN_ENABLED()
	table.foreach(spellInfo.current, function (eventName,info)
		if info.t and info.t ~= "" then -- call OnDurationEnded
			self:OnDurationEnded(eventName,true)
		end
	end)
end

function SpellReminder:OnDurationEnded(eventName,quiet)
	if spellInfo.current[eventName] == nil then return end
	local name = spellInfo.current[eventName].n
	local info = self.db.char.spellSetup[name]
	if not quiet then
		self:Pour(name.." has EXPIRED!",1,1,1,nil,nil,nil,true)
	end
	self:CancelScheduledEvent(eventName)
	candybar:StopCandyBar(eventName,false)
	candybar:UnregisterCandyBar(eventName)
	spellInfo.current[eventName] = nil
end

function SpellReminder:OnDurationEnding(eventName,quiet)
	if spellInfo.current[eventName] == nil then return end
	local name = spellInfo.current[eventName].n
--	local info = self.db.char.spellSetup[name]
	local reg, t, e, r = candybar:CandyBarStatus(eventName)

	if not quiet then
		self:Pour(name.." over in "..math.floor(t-e-1).." seconds!",1,1,1,nil,nil,nil,true)
	end
	self:GrowCandy(eventName)
end

function SpellReminder:GetTexture(name)
	local i = 1
	while true do
		local nm = GetSpellName(i, BOOKTYPE_SPELL)
		if not nm then break
		elseif nm == name then
			return GetSpellTexture(i, BOOKTYPE_SPELL)
		end
		i = i + 1
	end
	-- still not found? try pets spellbook
	local i = 1
	while true do
		local nm = GetSpellName(i, BOOKTYPE_PET)
		if not nm then break
		elseif nm == name then
			return GetSpellTexture(i, BOOKTYPE_PET)
		end
		i = i + 1
	end
end

function SpellReminder:GrowCandy(id)
	self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,GetTime()+getOption("ttg"))
end

function SpellReminder:GrowBar(id, stopTime)
	if not candybar:IsCandyBarRegistered(id) then return end
	if GetTime() > stopTime then
		candybar:SetCandyBarScale(id,getOption("stopScale"))
		candybar:RegisterCandyBarWithGroup(id,"SpellReminderEmphasis")
		return
	end
	local now = GetTime()
	local scale = (getOption("stopScale") - getOption("startScale")) * (1 - ((stopTime - now) / getOption("ttg")))
--	local centerX, centerY = self:GetCandyBarCenter(id)
	candybar:SetCandyBarScale(id,getOption("startScale") + scale)
	local effscale = UIParent:GetEffectiveScale()
	
	local posX = ((self.db.profile.barposition["emphasis"].x*effscale) - (self.db.profile.barposition["normal"].x*effscale)) * (1-((stopTime - now) / getOption("ttg"))) 
	local posY = ((self.db.profile.barposition["emphasis"].y*effscale) - (self.db.profile.barposition["normal"].y*effscale)) * (1-((stopTime - now) / getOption("ttg")))

	local point, rframe, rpoint = candybar:GetCandyBarPoint(id)
	candybar:SetCandyBarPoint(id, point, rframe, rpoint, posX/candybar:GetEffectiveScale(id), posY/candybar:GetEffectiveScale(id))
	
	self:ScheduleEvent("GrowBar_"..id,self.GrowBar,0,self,id,stopTime)
end

local tt = AceLibrary("Gratuity-2.0")   
function SpellReminder:GetDuration(spellName)
-- static timers
--	if staticDurations[spellName] ~= nil then return staticDurations[spellName] end

	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spell) then	break end
		if spell == spellName then
			tt:SetSpell(i,BOOKTYPE_SPELL)
			local tiptext = self:GetFullTipText(tt)
			return self:FindDurationInTip(tiptext)
		end
		i = i + 1
	end
	-- still not found? try pets spellbook
	local i = 1
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_PET)
		if (not spell) then	break end
		if spell == spellName then
			tt:SetSpell(i,BOOKTYPE_PET)
			local tiptext = self:GetFullTipText(tt)
			return self:FindDurationInTip(tiptext)
		end
		i = i + 1
	end
	
	return nil
end

function SpellReminder:FindDurationInTip(tiptext)
	local pre = {"for","over","lasts","up to"}
	local post = {"sec","min","hour"}
	local durationBuff = nil
	local durationDebuff = nil
	local newDur = nil
	table.foreach(pre, function(_,preVal) -- loop through prefixes
		preVal = string.lower(preVal)
		table.foreach(post, function(_,postVal)  -- loop through suffixes
			postVal = string.lower(postVal)
			for newDur in string.gmatch(string.lower(tiptext),preVal.." (%d+) "..postVal) do
				newDur = tonumber(newDur)
				if newDur ~= nil then
					if postVal == "min" then
						newDur = newDur * 60
					elseif postVal == "hour" then
						newDur = newDur * 60 * 60
					end
					if (durationBuff == nil) then
						durationBuff = newDur
					elseif (newDur > durationBuff) then
						durationDebuff = durationBuff
						durationBuff = newDur
					end
				end
			end
		end)
	end)
	
	return tonumber(durationBuff), tonumber(durationDebuff)
end

function SpellReminder:GetFullTipText(tt)
	local fullText = ""
	for i=1,tt:NumLines() do
		fullText = fullText..tt:GetLine(i)
	end
	return fullText
end
